/*[[
	Name := TDSGlobal
	Author := Copyright  2005 Bob O'Brien / Barcode
	Link := 
	Notes := Based on Alexander Elder's Triple Screen system. To be run only on a Weekly chart.
	Lots := 1
	Stop Loss := 0
	Take Profit := 100
	Trailing Stop := 60
]]*/
//+------------------------------------------------------------------+
//|  External Variables                                              |
//+------------------------------------------------------------------+

extern int    MagicNumber  = 10001;
extern double Lots         = 1.0;
extern int    TakeProfit   = 100;
extern int    Stoploss     =   0;
extern int    TrailingStop =  60;	
extern int    Slippage     =   5;
extern bool   UseTimeLimit = true;

//
//
//
//
//

double StartMinute1=0,EndMinute1=0,StartMinute2=0,EndMinute2=0,StartMinute3=0,EndMinute3=0;
double StartMinute4=0,EndMinute4=0,StartMinute5=0,EndMinute5=0,StartMinute6=0,EndMinute6=0;
double StartMinute7=0,EndMinute7=0;

double PriceOpen=0;
double NewPrice =0;
double newbar   =0;



//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   double pipMultiplier;
      if (Digits==3 || Digits==5)
            pipMultiplier = 10;
      else  pipMultiplier = 1;
        


   //
   //
   //	            
   //    Select a range of minutes in the day to start trading based on the currency pair.
   //    This is to stop collisions occurring when 2 or more currencies set orders at the same time.
   //
   //
   //

   bool symbolFound =false;
      if(checkSymbol("USDCHF")) { setMinutes(0,1, 8, 9,16,17,24,25,32,33,40,41,48,49);  symbolFound = true; }
      if(checkSymbol("GBPUSD")) { setMinutes(2,3,10,11,18,19,26,27,34,35,42,43,50,51);  symbolFound = true; }
      if(checkSymbol("USDJPY")) { setMinutes(4,5,12,13,20,21,28,29,36,37,44,45,52,53);  symbolFound = true; }
      if(checkSymbol("EURUSD")) { setMinutes(6,7,14,15,22,23,30,31,38,39,46,47,54,59);  symbolFound = true; }
      if(!symbolFound) return(0);

      if (UseTimeLimit)
         bool withinTimeLimit = ((Minute() >= StartMinute1 && Minute() <= EndMinute1) ||
                                 (Minute() >= StartMinute2 && Minute() <= EndMinute2) ||
                                 (Minute() >= StartMinute3 && Minute() <= EndMinute3) ||
                                 (Minute() >= StartMinute4 && Minute() <= EndMinute4) ||
                                 (Minute() >= StartMinute5 && Minute() <= EndMinute5) ||
                                 (Minute() >= StartMinute6 && Minute() <= EndMinute6) ||
                                 (Minute() >= StartMinute7 && Minute() <= EndMinute7));
      else withinTimeLimit=true;
	   if (!withinTimeLimit) return(0);

   //
   //
   //
   //
   //
         
      int TradesThisSymbol=0;
   	for(int i=OrdersTotal()-1; i>=0; i--)
      { 
         OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
            if(OrderMagicNumber()!=MagicNumber) continue;
            if(OrderSymbol()     !=Symbol()   ) continue;
            TradesThisSymbol ++;
      }
        
   //
   //
   //
   //
   //

      double MacdPrevious  = iMACD(NULL,PERIOD_W1,12,26,9,PRICE_CLOSE,MODE_MAIN,1);
      double MacdPrevious2 = iMACD(NULL,PERIOD_W1,12,26,9,PRICE_CLOSE,MODE_MAIN,2);
      double OsMAPrevious  = iOsMA(NULL,PERIOD_W1,12,26,9,PRICE_CLOSE,1);
      double OsMAPrevious2 = iOsMA(NULL,PERIOD_W1,12,26,9,PRICE_CLOSE,2);
     
      double Force    = iForce(NULL,PERIOD_D1,2,MODE_EMA,PRICE_CLOSE,1); 
      bool   ForcePos = Force > 0;
      bool   ForceNeg = Force < 0;

      //
      //
      //
      //
      //
         
      if (MacdPrevious >  MacdPrevious2) double Direction =  1;
      if (MacdPrevious <  MacdPrevious2)        Direction = -1;
      if (MacdPrevious == MacdPrevious2)        Direction =  0;
	  
      if (OsMAPrevious >  OsMAPrevious2) double OsMADirection =  1;
      if (OsMAPrevious <  OsMAPrevious2)        OsMADirection = -1;
      if (OsMAPrevious == OsMAPrevious2)        OsMADirection =  0;
	  

   //
   //
   //
   //
   //

   if (!IsTesting() || (IsTesting() && IsVisualMode()))
      Comment("TSD for MT4 ver beta 0.3 - DO NOT USE WITH REAL MONEY YET",
              "\n",
              "\n","Weekly MacdPrevious  = ",MacdPrevious,"    Weekly OsMAPrevious = ",OsMAPrevious,
              "\n","Weekly MacdPrevious2 = ",MacdPrevious2,"    Weekly OsMAPrevious2 = ",OsMAPrevious2,
              "\n","Weekly Direction = ",Direction,"    Weekly OsMADirection = ",OsMADirection,
              "\n",
              "\n","Daily Force = ",Force,
              "\n","Is Daily Force Bullish = ",ForcePos,
              "\n","Is Daily Force Bearish = ",ForceNeg,
              "\n",
              "\n","Total Orders = ",OrdersTotal(),
              "\n","Trades this Symbol(",Symbol(),") = ",TradesThisSymbol,
              "\n",
              "\n","New Bar Time is ",TimeToStr(newbar),
              "\n",
              "\n","Daily High[1] = ",High[1],
              "\n","Daily High[2] = ",High[2],
              "\n","Daily Low[1] = " ,Low[1],
              "\n","Daily Low[2] = " ,Low[2],
              "\n",
              "\n","Current Ask Price + 16 pips = ",Ask+(16*Point*pipMultiplier),
              "\n","Current Bid Price - 16 pips = ",Bid-(16*Point*pipMultiplier));
        
   //
   //
   //
   //
   //

      double tp = NormalizeDouble(TakeProfit  *Point*pipMultiplier,Digits);
      double ts = NormalizeDouble(TrailingStop*Point*pipMultiplier,Digits);
   
   //
   //
   //
   //
   //
   
   RefreshRates();
   if(newbar != Time[0]) 
   {
      newbar = Time[0];

      //
      //
      //
      //
      //
                 	 
      if(TradesThisSymbol < 1) 
	   {
         if(OsMADirection == 1 && ForceNeg)
         {
            PriceOpen = High[1] + 1*Point*pipMultiplier;
            if(PriceOpen > (Ask + 16*Point*pipMultiplier))
            {
               OrderSend(Symbol(),OP_BUYSTOP,Lots,PriceOpen,Slippage,Low[1]-1*Point*pipMultiplier,PriceOpen+tp,"Buy Entry Order placed at "+CurTime(),MagicNumber,0,Green);
               return(0);
			   }
			   else
			   {
               NewPrice = Ask + 16*Point*pipMultiplier;
               OrderSend(Symbol(),OP_BUYSTOP,Lots,NewPrice,Slippage,Low[1]-1*Point*pipMultiplier,NewPrice+tp,"Buy Entry Order placed at "+CurTime(),MagicNumber,0,Green);
               return(0);
			   }
         }
      
         //
         //
         //
         //
         //
     
         if(OsMADirection == -1 && ForcePos)
         {
            PriceOpen = Low[1] - 1*Point*pipMultiplier;
			   if(PriceOpen < (Bid - 16*Point*pipMultiplier))
			   {
               OrderSend(Symbol(),OP_SELLSTOP,Lots,PriceOpen,Slippage,High[1] + 1*Point*pipMultiplier,PriceOpen-tp,"Sell Entry Order placed at "+CurTime(),MagicNumber,0,Green);
               return(0);
            }
            else
            {
               NewPrice = Bid - 16*Point*pipMultiplier;
               OrderSend(Symbol(),OP_SELLSTOP,Lots,NewPrice,Slippage,High[1] + 1*Point*pipMultiplier,NewPrice-tp,"Sell Entry Order placed at "+CurTime(),MagicNumber,0,Green);
               return(0);
            }
         }
      }

      //
      //
      //    Pending Order Management
      //
      //

      if(TradesThisSymbol > 0)
      {
         for(i=OrdersTotal()-1; i>=0; i--)
  	      { 
     	      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
            if(OrderSymbol()     !=Symbol())    continue;
            if(OrderMagicNumber()!=MagicNumber) continue;

            //
            //
            //
            //
            //
                  
            if(OrderType()==OP_BUYSTOP)
            {
               if(OsMADirection == -1)
               { 
  				      OrderDelete(OrderTicket());
                  return(0); 
               } 
               if(High[1]<High[2])
               if(High[1]>(Ask+16*Point*pipMultiplier))
               {  
                  OrderModify(OrderTicket(),High[1]+1*Point*pipMultiplier,Low[1]-1*Point*pipMultiplier,OrderTakeProfit(),0,Cyan);
                  return(0);
 			      }
  			      else
  			      {
                  OrderModify(OrderTicket(),Ask+16*Point*pipMultiplier,Low[1]-1*Point*pipMultiplier,OrderTakeProfit(),0,Cyan);
                  return(0);					
               }	  			      
			   }
				
            //
			   //
			   //
			   //
			   //

            if(OrderType()==OP_SELLSTOP)
            {
               if(OsMADirection == 1)
  				   { 
                  OrderDelete(OrderTicket());
                  return(0); 
               }
               if(Low[1]>Low[2])
               if(Low[1]<(Bid-16*Point*pipMultiplier))
               {
                  OrderModify(OrderTicket(),Low[1]-1*Point*pipMultiplier,High[1]+1*Point*pipMultiplier,OrderTakeProfit(),0,Cyan);
                  return(0);					
               }
               else
					{
                  OrderModify(OrderTicket(),Bid-16*Point*pipMultiplier,High[1]+1*Point*pipMultiplier,OrderTakeProfit(),0,Cyan);
                  return(0);					
					}
            }
         }            
      }
   }

   //
   //
   //    Stop Loss Management
   //
   //

   if(TradesThisSymbol > 0)
   {
      for(i=OrdersTotal()-1; i>=0; i--)
      { 
         if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES) == false) break;
         if(OrderSymbol()     !=Symbol())    continue;
         if(OrderMagicNumber()!=MagicNumber) continue;

         //
         //
         //
         //
         //
         
         if(OrderType()==OP_BUY)
         {
            if(Ask-OrderOpenPrice() > (ts))
            { 
               if(OrderStopLoss() < (Ask-ts))
               { 
                  OrderModify(OrderTicket(),OrderOpenPrice(),Ask-ts,Ask+tp,0,Cyan);
                  return(0);
               }
            }
         }            
         if(OrderType()==OP_SELL)
         {
            if(OrderOpenPrice()-Bid > (ts))
            { 
               if(OrderStopLoss() > (Bid+ts))
               { 
                  OrderModify(OrderTicket(),OrderOpenPrice(),Bid+ts,Bid-tp,0,Cyan);
                  return(0);					
               }
            }            
         }
      }
   }

   //
   //
   //
   //
   //

   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

bool checkSymbol(string compareToWhat) { return(StringFind(Symbol(),compareToWhat) > -1); }
void setMinutes(int sminute1, int eminute1,
                int sminute2, int eminute2,
                int sminute3, int eminute3,
                int sminute4, int eminute4,
                int sminute5, int eminute5,
                int sminute6, int eminute6,
                int sminute7, int eminute7)
{
   StartMinute1 = sminute1;  EndMinute1 = eminute1;
   StartMinute2 = sminute2;  EndMinute2 = eminute2;
   StartMinute3 = sminute3;  EndMinute3 = eminute3;
   StartMinute4 = sminute4;  EndMinute4 = eminute4;
   StartMinute5 = sminute5;  EndMinute5 = eminute5;
   StartMinute6 = sminute6;  EndMinute6 = eminute6;
   StartMinute7 = sminute7;  EndMinute7 = eminute7;
}